package com.ibm.ift;

import com.ibm.broker.javacompute.MbJavaComputeNode;
import com.ibm.broker.plugin.MbElement;
import com.ibm.broker.plugin.MbException;
import com.ibm.broker.plugin.MbMessage;
import com.ibm.broker.plugin.MbMessageAssembly;
import com.ibm.broker.plugin.MbOutputTerminal;
import com.ibm.broker.plugin.MbUserException;

public class Authenticate_with_IFT_expiredtoken extends MbJavaComputeNode {

	public void evaluate(MbMessageAssembly inAssembly) throws MbException {
		MbOutputTerminal out = getOutputTerminal("out");
		MbOutputTerminal alt = getOutputTerminal("alternate");

		MbMessage inMessage = inAssembly.getMessage();
		MbMessageAssembly outAssembly = null;
		try {
			// create new message as a copy of the input
			MbMessage outMessage = new MbMessage(inMessage);
			outAssembly = new MbMessageAssembly(inAssembly, outMessage);
			// ----------------------------------------------------------
			// Add user code below

			// get the current time in seconds since epoch
			Long curr_time = System.currentTimeMillis() / 1000L;
			Long exp_time = 0L;
			
			
			String exp_time_str = null; 
			
			MbElement mbe = inAssembly.getLocalEnvironment().getRootElement().getFirstElementByPath("/Variables/IFT/iam_token/expiration");
			
			if (mbe != null) {
				exp_time_str = mbe.getValueAsString();
				exp_time = Long.parseLong(exp_time_str);
			} else {
				exp_time = Long.parseLong("0");
			}
			
			
			if (( exp_time - curr_time) <= 0) {
				alt.propagate(outAssembly);
				return;
			} // else route through the renew token flow connected to the "out" terminal
			

			
			// End of user code
			// ----------------------------------------------------------
		} catch (MbException e) {
			// Re-throw to allow Broker handling of MbException
			throw e;
		} catch (RuntimeException e) {
			// Re-throw to allow Broker handling of RuntimeException
			throw e;
		} catch (Exception e) {
			// Consider replacing Exception with type(s) thrown by user code
			// Example handling ensures all exceptions are re-thrown to be handled in the flow
			throw new MbUserException(this, "evaluate()", "", "", e.toString(),
					null);
		}
		// The following should only be changed
		// if not propagating message to the 'out' terminal
		out.propagate(outAssembly);

	}

}
